Imports MySql.Data
Imports MySql.Data.MySqlClient

Partial Class _404
    Inherits System.Web.UI.Page

    Protected Sub Page_Load(ByVal sender As Object, ByVal e As System.EventArgs) Handles Me.Load

        ' This page should be loaded when the requested webpage not could be found (404). When this page loads
        ' we catch the url that looks something like this: 
        ' ?404;http://www.mywebpage.com:80/something/some.htm : and puts this url in the string "query".

        Dim query As String = Request.Url.Query.ToString()

        ' The Try/Catch/Finally block is used to handle exceptions.
        Try

            If query.ToString().EndsWith(".htm") Then

                ' We create an array list by splitting up the url by the semicolon sign (:) and should therefore
                ' get the url in three parts. The first part is 0, the second part is 1 and the third part is 2. 
                ' We want to get the information in the third part (2) and this information hopefully has 
                ' a corresponding post in our "301Redirect table".

                ' Split the url in three parts.
                Dim parts As String() = query.Split(":")

                ' Assign the third part (index 2) to the value for a hidden field.
                HiddenUrl.Value = parts(2).ToString()

                ' Create a new string that should include the new url.
                Dim strNewURL As String = String.Empty

                Try
                    ' We select the "NewUrl" from the "Redirect" table where the "HiddenUrl.Value" corresponds to
                    ' the old url "OldUrl" in our "Redirect" table and makes a 301 Redirect to the new url.

                    Dim ConnString As String = ConfigurationManager.ConnectionStrings("ConnectionString").ToString()
                    Dim sql As String = "SELECT NewUrl FROM Redirect WHERE OldUrl=@OldUrl"

                    ' The Using block is used to call dispose (close) automatically even if there are an exception.
                    Using cn As New MySqlConnection(ConnString), _
                          cmd As New MySqlCommand(sql, cn)
                        cmd.Parameters.Add("@OldUrl", MySqlDbType.VarChar, 80).Value = HiddenUrl.Value

                        cn.Open()

                        ' Execute the select statement and put the value in the "strNewURL" string.

                        strNewURL = Convert.ToString(cmd.ExecuteScalar())

                        ' This is the 301 Redirect code
                        Response.Status = "301 Moved Permanently"
                        Response.StatusCode = 301
                        Response.AddHeader("Location", strNewURL)

                    End Using
                Catch ex As MySqlException
                    Response.Write(ex.Message)
                End Try

            End If

        Catch ex As Exception
            Response.Write(ex.Message)
        End Try

    End Sub
End Class
